/* sample of base notes (all notes in first octave) */
#include <stdio.h>
#include <ncurses.h>
#include "musicalbeep.h"

float get_keys(void);
bool HELL = 0;

int main()
{
	struct beep_parms_t mynote;
	WINDOW *mw;
	mw = initscr();
	noecho();
	cbreak();
	keypad(mw, TRUE);
	nodelay(mw, TRUE);

	mynote.octave = 1;
	mynote.tempo = 120;
	mynote.length = SIXTEENTH_NOTE;
	
	mvprintw(12,10,"Simple Keyboard: press a,w,s,d,r,f,t,g,h,u,j,i for notes");
	mvprintw(13,10,"                   Press q to quit");
	mvprintw(14,27,"Note: ");
	
	while (!HELL)
	{
		fflush(stdin);
		mynote.note = get_keys();
		if (mynote.note > 0)
			play_beep(mynote);
	}
	endwin();	
	return(0);
}

float get_keys(void)
{
        chtype keyring;

        if ( (int)(keyring = getch()) != ERR )
        {
		switch (keyring)
		{
           	case 'a': 
			mvprintw(14,33,"NOTE_A      ");
			return(NOTE_A);	
			case 'w': 
			mvprintw(14,33,"NOTE_A_SHARP");
			return(NOTE_A_SHARP);
			case 's': 
			mvprintw(14,33,"NOTE_B      ");
			return(NOTE_B);
			case 'd':
			mvprintw(14,33,"NOTE_C      ");
			return(NOTE_C);
			case 'r': 
			mvprintw(14,33,"NOTE_D_FLAT "); // a little variety!
			return(NOTE_D_FLAT);
			case 'f':
			mvprintw(14,33,"NOTE_D      ");
			return(NOTE_D);
			case 't':
			mvprintw(14,33,"NOTE_D_SHARP");
			return(NOTE_D_SHARP);
			case 'g':
			mvprintw(14,33,"NOTE_E      ");
			return(NOTE_E);
			case 'h':
			mvprintw(14,33,"NOTE_F      ");
			return(NOTE_F);
			case 'u':
			mvprintw(14,33,"NOTE_F_SHARP");
			return(NOTE_F_SHARP);
			case 'j':
			mvprintw(14,33,"NOTE_G      ");
			return(NOTE_G);
			case 'i':
			mvprintw(14,33,"NOTE_G_SHARP");
			return(NOTE_G_SHARP);
			case 'q':
			mvprintw(14,33,"   QUIT!    ");
			HELL = 1;
			break;
			default:
			return(0.0);
		}
	}
	return(0.0); /* to appease the compiler warning gods */
}


